/*****************************************************************************
 * LUTImage.h
 ***************************************************************************** 
 *
 * Project:     Halcon/C++
 * Description: Types for char-images with color table
 *
 * (c) 1996-2000 by MVTec Software GmbH
 *                  Neherstr. 1, 81675 Muenchen, Germany
 * 
 *****************************************************************************
 *
 * $Revision: 1.7 $
 * $Date: 2000/02/25 08:36:40 $
 *
 */


#ifndef H_LUT_IMAGE_H
#define H_LUT_IMAGE_H



class LIntExport HLUTImage: public HSemAbstractImage {
public:
  HLUTImage(void);
  HLUTImage(const char *file);
  HLUTImage(const HByteImage &image);
  HLUTImage(const HByteImage &image, const HByteLUT &lut);
  HLUTImage(const HLUTImage &image);
  virtual ~HLUTImage(void);
  
  // Tools
  char *ClassName(void) const { return "HLUTImage"; }
  operator HRGBImage(void) const;
  HRGBLUT GetLUT(void) const;
  HRGBLUT SetLUT(void);

  // Klassenoperationen
  static long NumInst(void) { return num_images; }
protected:
private:
  HByteImage  image;
  HByteLUT     lut;
  static long num_images;
};


#endif
